## ccache 4.7.2

=== unittest/CMakeLists.txt ===
set(
  source_files
  TestUtil.cpp
  main.cpp
  test_Args.cpp
  test_AtomicFile.cpp
  test_Config.cpp
  test_Depfile.cpp
  test_Hash.cpp
  test_Stat.cpp
  test_Util.cpp
  test_argprocessing.cpp
  test_ccache.cpp
  test_compopt.cpp
  test_compression_types.cpp
  test_core_MsvcShowIncludesOutput.cpp
  test_core_Statistics.cpp
  test_core_StatisticsCounters.cpp
  test_core_StatsLog.cpp
  test_hashutil.cpp
  test_storage_local_StatsFile.cpp
  test_storage_local_util.cpp
  test_util_Bytes.cpp
  test_util_LockFile.cpp
  test_util_TextTable.cpp
  test_util_TimePoint.cpp
  test_util_Tokenizer.cpp
  test_util_XXH3_128.cpp
  test_util_XXH3_64.cpp
  test_util_expected.cpp
  test_util_file.cpp
  test_util_path.cpp
  test_util_string.cpp
  test_util_zstd.cpp
)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files test_InodeCache.cpp)
endif()

if(WIN32)
  list(APPEND source_files test_bsdmkstemp.cpp test_Win32Util.cpp)
endif()

file(GLOB headers *.hpp)
list(APPEND source_files ${headers})

add_executable(unittest ${source_files})

if(MSVC)
  # Turn off /Zc:preprocessor for this test because it triggers a bug in some older Windows 10 SDK headers.
  set_source_files_properties(test_Stat.cpp PROPERTIES COMPILE_FLAGS /Zc:preprocessor-)
endif()

target_link_libraries(
  unittest
  PRIVATE standard_settings standard_warnings ccache_framework third_party)

target_include_directories(unittest PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${ccache_SOURCE_DIR}/src)

add_test(NAME unittest COMMAND unittest)

=== src/core/CMakeLists.txt ===
set(
  sources
  CacheEntry.cpp
  Manifest.cpp
  Result.cpp
  ResultExtractor.cpp
  ResultInspector.cpp
  ResultRetriever.cpp
  MsvcShowIncludesOutput.cpp
  Statistics.cpp
  StatisticsCounters.cpp
  StatsLog.cpp
  mainoptions.cpp
  types.cpp
)

file(GLOB headers *.hpp)
list(APPEND sources ${headers})

target_sources(ccache_framework PRIVATE ${sources})

=== debian/changelog ===
ccache (4.7.2-1) unstable; urgency=medium

  * New upstream release 4.7.2 (closes: #1022704)

 -- Joel Rosdahl <joel@debian.org>  Sat, 29 Oct 2022 16:52:18 +0200

ccache (4.7.1-1) unstable; urgency=medium

  * New upstream release 4.7.1

 -- Joel Rosdahl <joel@debian.org>  Sun, 23 Oct 2022 20:20:24 +0200

ccache (4.7-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

  [ Joel Rosdahl ]
  * New upstream release 4.7
  * Bump Standards-Version to 4.6.1 with no changes
  * Update Debian-specific documentation patch
  * Update debian/copyright

 -- Joel Rosdahl <joel@debian.org>  Tue, 18 Oct 2022 21:43:05 +0200

## ccache 4.7.3

=== debian/changelog ===
ccache (4.7.3-1) unstable; urgency=medium

  * New upstream release 4.7.3

 -- Joel Rosdahl <joel@debian.org>  Sat, 05 Nov 2022 22:29:17 +0100

## ccache 4.7.4

=== debian/changelog ===
ccache (4.7.4-1) unstable; urgency=medium

  * New upstream release 4.7.4

 -- Joel Rosdahl <joel@debian.org>  Mon, 21 Nov 2022 20:40:46 +0100

## ccache 4.8+really4.7.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(ccache LANGUAGES C CXX ASM ASM_MASM)
if(MSVC)
  enable_language(ASM_MASM)
else()
  enable_language(ASM)
endif()
set(CMAKE_PROJECT_DESCRIPTION "a fast C/C++ compiler cache")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED YES)
set(CMAKE_C_EXTENSIONS NO)

# Always export compile_commands.json since it's useful for many tools.
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Minimum compiler requirements (fail gracefully instead of producing cryptic
# C++ error messages)
#

if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.8)
   OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
   OR (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0))
  message(
    FATAL_ERROR
    "The compiler you are using is too old, sorry.\n"
    "You need one listed here: https://ccache.dev/platform-compiler-language-support.html")
endif()

if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4)
    OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6))
  message(
    WARNING
    "The compiler you are using is rather old.\n"
    "If anything goes wrong you might be better off with one listed here:"
    " https://ccache.dev/platform-compiler-language-support.html")

  # Warnings from old compilers are probably useless anyway.
  option(WARNINGS_AS_ERRORS "Treat compiler warnings as errors" FALSE)
endif()

#
# Settings
#
include(CcacheVersion)

if(NOT DEFINED CCACHE_DEV_MODE)
  if("${CCACHE_VERSION_ORIGIN}" STREQUAL git OR DEFINED ENV{CI})
    set(CCACHE_DEV_MODE ON)
  else()
    set(CCACHE_DEV_MODE OFF)
  endif()
endif()
message(STATUS "Ccache dev mode: ${CCACHE_DEV_MODE}")

option(ENABLE_IPO "Enable interprocedural (link time, LTO) optimization" OFF)
if(ENABLE_IPO AND NOT MINGW)
  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
endif()

include(UseFastestLinker)
include(StandardSettings)
include(StandardWarnings)
include(CIBuildType)
include(DefaultBuildType)

#
# Configuration
#

include(InstallDirs)
include(GenerateConfigurationFile)
include(GenerateVersionFile)

#
# Static link configuration
#

set(STATIC_LINK_DEFAULT OFF)
if(WIN32)
  set(STATIC_LINK_DEFAULT ON)
endif()

option(STATIC_LINK "Prefer linking libraries statically" ${STATIC_LINK_DEFAULT})

if(STATIC_LINK)
  list(INSERT CMAKE_FIND_LIBRARY_SUFFIXES 0 "${CMAKE_STATIC_LIBRARY_SUFFIX}")
  set(CMAKE_LINK_SEARCH_START_STATIC ON)

  # Link MSVC runtime statically.
  if(MSVC)
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
  # Link MINGW runtime statically.
  elseif(WIN32)
    if((CMAKE_CXX_COMPILER_ID STREQUAL GNU) OR (CMAKE_CXX_COMPILER_ID STREQUAL Clang))
      list(APPEND CCACHE_EXTRA_LIBS -static-libgcc -static-libstdc++ -static -lwinpthread -dynamic)
    endif()
    if(CMAKE_CXX_COMPILER_ID STREQUAL Clang)
      list(APPEND CCACHE_EXTRA_LIBS -fuse-ld=lld)
    endif()
  endif()
endif()

#
# Third party
#
option(ZSTD_FROM_INTERNET
  "Download and use libzstd from the Internet if not available" ON)
option(HIREDIS_FROM_INTERNET
  "Download and use libhiredis from the Internet if not available" ON)

find_package(zstd 1.1.2 MODULE REQUIRED)

option(REDIS_STORAGE_BACKEND "Enable Redis remote storage" ON)

if(REDIS_STORAGE_BACKEND)
  find_package(hiredis 0.13.3 MODULE REQUIRED)
endif()

#
# Special flags
#
# Note: Cppcheck will scan everything after this point. zstd is above so it
# doesn't get scanned.
#
include(CodeAnalysis)
option(ENABLE_TRACING "Enable possibility to use internal ccache tracing" OFF)

#
# Source code
#
add_subdirectory(src)

#
# ccache executable
#
add_executable(ccache src/main.cpp)
target_link_libraries(ccache PRIVATE standard_settings standard_warnings ccache_framework)

#
# Documentation
#
option(ENABLE_DOCUMENTATION "Enable documentation" ON)
if(ENABLE_DOCUMENTATION)
  add_subdirectory(doc)
endif()

#
# Installation
#
install(TARGETS ccache DESTINATION ${CMAKE_INSTALL_BINDIR})

#
# Packaging
#
include(CcachePackConfig)

#
# Tests
#
option(ENABLE_TESTING "Enable tests" ON)
if(ENABLE_TESTING)
  enable_testing()
  add_subdirectory(unittest)
  add_subdirectory(test)

  # Note: VERSION_GREATER_EQUAL requires CMake 3.17
  if(NOT ${CMAKE_VERSION} VERSION_LESS "3.17")
    list(APPEND CMAKE_CTEST_ARGUMENTS "--output-on-failure")
  endif()

  # Add "check" target which compiles and runs tests.
  set(
    check_command
    ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure)
  if(CMAKE_CONFIGURATION_TYPES)
    list(APPEND check_command --build-config "$<CONFIGURATION>")
  endif()
  add_custom_target(
    check
    COMMAND ${check_command}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    DEPENDS ccache unittest)
endif()

#
# Special formatting targets
#
add_custom_target(
  format
  COMMAND misc/format-files --all
  COMMENT "Formatting code"
  USES_TERMINAL
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_custom_target(
  check_format
  COMMAND misc/format-files --all --check
  COMMENT "Checking code formatting"
  USES_TERMINAL
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== src/CMakeLists.txt ===
set(
  source_files
  Args.cpp
  AtomicFile.cpp
  Config.cpp
  Context.cpp
  Depfile.cpp
  Fd.cpp
  Hash.cpp
  Logging.cpp
  ProgressBar.cpp
  SignalHandler.cpp
  Stat.cpp
  TemporaryFile.cpp
  ThreadPool.cpp
  Util.cpp
  argprocessing.cpp
  assertions.cpp
  ccache.cpp
  compopt.cpp
  execute.cpp
  hashutil.cpp
  language.cpp
  version.cpp
)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files InodeCache.cpp)
endif()

if(MTR_ENABLED)
  list(APPEND source_files MiniTrace.cpp)
endif()

if(WIN32)
  list(APPEND source_files Win32Util.cpp)
endif()

file(GLOB headers *.hpp)
list(APPEND source_files ${headers})

add_library(ccache_framework STATIC ${source_files})

if(WIN32)
  list(APPEND CCACHE_EXTRA_LIBS psapi)
endif()

if(CCACHE_EXTRA_LIBS)
  target_link_libraries(
    ccache_framework
    PRIVATE "${CCACHE_EXTRA_LIBS}"
  )
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(
  ccache_framework
  PRIVATE standard_settings standard_warnings ZSTD::ZSTD Threads::Threads third_party
)

target_include_directories(ccache_framework PUBLIC ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

if(REDIS_STORAGE_BACKEND)
  target_compile_definitions(ccache_framework PUBLIC -DHAVE_REDIS_STORAGE_BACKEND)
  target_link_libraries(
    ccache_framework
    PUBLIC standard_settings standard_warnings HIREDIS::HIREDIS third_party
  )
endif()

add_executable(test-lockfile test_lockfile.cpp)
target_link_libraries(test-lockfile PRIVATE standard_settings standard_warnings ccache_framework)

add_subdirectory(core)
add_subdirectory(storage)
add_subdirectory(third_party)
add_subdirectory(util)

=== unittest/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
   test_storage_local_StatsFile.cpp
   test_storage_local_util.cpp
   test_util_Bytes.cpp
+  test_util_Duration.cpp
   test_util_LockFile.cpp
   test_util_TextTable.cpp
   test_util_TimePoint.cpp

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -2,11 +2,11 @@
   sources
   CacheEntry.cpp
   Manifest.cpp
+  MsvcShowIncludesOutput.cpp
   Result.cpp
   ResultExtractor.cpp
   ResultInspector.cpp
   ResultRetriever.cpp
-  MsvcShowIncludesOutput.cpp
   Statistics.cpp
   StatisticsCounters.cpp
   StatsLog.cpp

=== src/third_party/CMakeLists.txt ===
add_library(third_party STATIC base32hex.c format.cpp httplib.cpp url.cpp xxhash.c)
if(NOT MSVC)
  target_sources(third_party PRIVATE getopt_long.c)
else()
  target_sources(third_party PRIVATE win32/getopt.c)
  target_compile_definitions(third_party PUBLIC -DSTATIC_GETOPT)
endif()

if(WIN32)
  target_sources(third_party PRIVATE win32/mktemp.c)
endif ()

if(ENABLE_TRACING)
  target_sources(third_party PRIVATE minitrace.c)
endif()

file(GLOB headers *.h fmt/*.h nonstd/*.hpp win32/*.h)
target_sources(third_party PRIVATE ${headers})

set(xxhdispatchtest [=[
#include "xxh_x86dispatch.c"

int main()
{
  XXH3_64bits_dispatch("foo", 3);
  return 1;
}
]=])

file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/xxhdispatchtest.c" "${xxhdispatchtest}")

try_compile(USE_XXH_DISPATCH ${CMAKE_CURRENT_BINARY_DIR}
  "${CMAKE_CURRENT_BINARY_DIR}/xxhdispatchtest.c"
  CMAKE_FLAGS "-DINCLUDE_DIRECTORIES=${CMAKE_CURRENT_SOURCE_DIR}"
  COMPILE_DEFINITIONS "-DXXH_STATIC_LINKING_ONLY")

target_compile_definitions(third_party INTERFACE "-DXXH_STATIC_LINKING_ONLY")
if(USE_XXH_DISPATCH)
  target_sources(third_party PRIVATE xxh_x86dispatch.c)
  target_compile_definitions(third_party INTERFACE "-DUSE_XXH_DISPATCH")
endif()

# Treat third party headers as system files (no warning for those headers).
target_include_directories(
  third_party
  PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} SYSTEM
)

target_link_libraries(third_party PRIVATE standard_settings)
target_link_libraries(third_party INTERFACE blake3)

if(WIN32)
  target_link_libraries(third_party PRIVATE ws2_32)
endif()

# Silence warning from winbase.h due to /Zc:preprocessor.
if(MSVC)
  target_compile_options(third_party PRIVATE /wd5105)
endif()

add_subdirectory(blake3)

=== src/util/CMakeLists.txt ===
set(
  sources
  Bytes.cpp
  LockFile.cpp
  TextTable.cpp
  TimePoint.cpp
  Tokenizer.cpp
  file.cpp
  path.cpp
  string.cpp
  zstd.cpp
)

file(GLOB headers *.hpp)
list(APPEND sources ${headers})

target_sources(ccache_framework PRIVATE ${sources})

=== src/storage/local/CMakeLists.txt ===
set(
  sources
  CacheFile.cpp
  LocalStorage.cpp
  LocalStorage_cleanup.cpp
  LocalStorage_compress.cpp
  LocalStorage_statistics.cpp
  StatsFile.cpp
  util.cpp
)

file(GLOB headers *.hpp)
list(APPEND sources ${headers})

target_sources(ccache_framework PRIVATE ${sources})

=== src/storage/remote/CMakeLists.txt ===
set(
  sources
  FileStorage.cpp
  HttpStorage.cpp
  RemoteStorage.cpp
)

if(REDIS_STORAGE_BACKEND)
  list(APPEND sources RedisStorage.cpp)
endif()

file(GLOB headers *.hpp)
list(APPEND sources ${headers})

target_sources(ccache_framework PRIVATE ${sources})

=== src/third_party/blake3/CMakeLists.txt ===
add_library(blake3 STATIC blake3.c blake3_dispatch_ccache.c blake3_portable.c)

target_link_libraries(blake3 PRIVATE standard_settings)

if(MSVC)
  # No object file is created if masm is passed the compile options from standard_settings,
  # so don't pass any flags at all to assembler (as no flags are needed anyway).
  string(REPLACE "<FLAGS> " "" CMAKE_ASM_MASM_COMPILE_OBJECT "${CMAKE_ASM_MASM_COMPILE_OBJECT}")
endif()

include(CheckCSourceCompiles)

function(add_source_if_enabled feature msvc_flags others_flags intrinsic)
  if(MSVC)
    set(compile_flags "${msvc_flags}")
  else()
    set(compile_flags "${others_flags}")
  endif()

  if(MSVC)
    set(suffix "_x86-64_windows_msvc.asm")
  elseif(WIN32)
    set(suffix "_x86-64_windows_gnu.S")
  else()
    set(suffix "_x86-64_unix.S")
  endif()

  # First check if it's possible to use the assembler variant for the feature.
  string(TOUPPER "have_asm_${feature}" have_feature)
  if(NOT DEFINED "${have_feature}" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    if(NOT CMAKE_REQUIRED_QUIET)
      message(STATUS "Performing Test ${have_feature}")
    endif()

    set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)

    # Must set CMAKE_ASM_MASM_CREATE_STATIC_LIBRARY explicitly otherwise try_compile
    # fails, see https://discourse.cmake.org/t/building-lib-file-from-asm-cmake-bug/1959
    try_compile(
      ${have_feature}
      ${CMAKE_CURRENT_BINARY_DIR}
      "${CMAKE_CURRENT_SOURCE_DIR}/blake3_${feature}${suffix}"
      CMAKE_FLAGS -DCMAKE_ASM_MASM_CREATE_STATIC_LIBRARY=${CMAKE_C_CREATE_STATIC_LIBRARY}
      COMPILE_DEFINITIONS ${compile_flags})

    unset(CMAKE_TRY_COMPILE_TARGET_TYPE)

    if(NOT CMAKE_REQUIRED_QUIET)
      if (${${have_feature}})
        message(STATUS "Performing Test ${have_feature} - Success")
      else()
        message(STATUS "Performing Test ${have_feature} - Failed")
      endif()
    endif()
  endif()

  # If the assembler variant didn't work, try the c variant.
  if(NOT ${have_feature})
    string(TOUPPER "have_c_${feature}" have_feature)
    set(suffix ".c")

    set(CMAKE_REQUIRED_FLAGS ${compile_flags})
    check_c_source_compiles(
      [=[
        #include <immintrin.h>
        int main() { ${intrinsic}; return 0; }
      ]=]
      ${have_feature})
    unset(CMAKE_REQUIRED_FLAGS)
  endif()

  if(${have_feature})
    target_sources(blake3 PRIVATE blake3_${feature}${suffix})
    if(suffix STREQUAL ".c")
      if(MINGW AND feature STREQUAL "avx512")
        # Workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=65782.
        # Taken from blake3's build.rs.
        set(compile_flags "${compile_flags} -fno-asynchronous-unwind-tables")
      endif()
      set_property(
        SOURCE blake3_${feature}${suffix}
        APPEND PROPERTY COMPILE_FLAGS ${compile_flags})
    elseif(NOT MSVC)
      set_property(
        SOURCE blake3_${feature}${suffix}
        PROPERTY COMPILE_FLAGS ${compile_flags})
    endif()
  else()
    string(TOUPPER "blake3_no_${feature}" no_feature)
    target_compile_definitions(blake3 PRIVATE ${no_feature})
  endif()
endfunction()

# https://software.intel.com/sites/landingpage/IntrinsicsGuide/
add_source_if_enabled(sse2 "" "-msse2"
  "_mm_set1_epi32(42)")
add_source_if_enabled(sse41 "" "-msse4.1"
  "_mm_test_all_ones(_mm_set1_epi32(42))")
add_source_if_enabled(avx2 "/arch:AVX2" "-mavx2"
  "_mm256_abs_epi8(_mm256_set1_epi32(42))")
add_source_if_enabled(avx512 "/arch:AVX512" "-mavx512f -mavx512vl"
  "_mm256_abs_epi64(_mm256_set1_epi32(42))")

# Neon is always available on AArch64
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  # https://developer.arm.com/architectures/instruction-sets/simd-isas/neon/intrinsics
  check_c_source_compiles(
    [=[
      #include <arm_neon.h>
      int main() { vdupq_n_s32(42); return 0; }
    ]=]
    HAVE_NEON)
  if(HAVE_NEON)
    target_sources(blake3 PRIVATE blake3_neon.c)
    target_compile_definitions(blake3 PRIVATE BLAKE3_USE_NEON)
  endif()
endif()

file(GLOB headers *.h)
target_sources(blake3 PRIVATE ${headers})

=== debian/changelog ===
ccache (4.8+really4.7.5-1) unstable; urgency=medium

  * New upstream release 4.7.5, fixing an issue with hanging processes by
    a small change of a default setting compared to version 4.7.4
    (closes: #1033191)

 -- Joel Rosdahl <joel@debian.org>  Thu, 23 Mar 2023 08:39:58 +0100

ccache (4.8-1) unstable; urgency=medium

  * New upstream release 4.8, which fixes an issue with hanging processes

 -- Joel Rosdahl <joel@debian.org>  Sun, 19 Mar 2023 10:32:54 +0100

=== debian/control ===
Source: ccache
Section: devel
Priority: optional
Maintainer: Joel Rosdahl <joel@debian.org>
Build-Depends: debhelper-compat (= 13), elfutils, cmake, libzstd-dev, libhiredis-dev (>= 0.14.1), asciidoctor
Standards-Version: 4.6.1
Homepage: https://ccache.dev
Vcs-Browser: https://salsa.debian.org/debian/ccache
Vcs-Git: https://salsa.debian.org/debian/ccache.git

Package: ccache
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: distcc | icecc
Description: Compiler cache for fast recompilation of C/C++ code
 Ccache is a compiler cache. It speeds up recompilation by caching
 previous compilations and detecting when the same compilation is
 being done again.

## ccache 4.8.2

=== debian/changelog ===
ccache (4.8.2-1) unstable; urgency=medium

  * New upstream release 4.8.2

 -- Joel Rosdahl <joel@debian.org>  Sun, 23 Jul 2023 09:17:51 +0200

## ccache 4.8.3

=== debian/changelog ===
ccache (4.8.3-1) unstable; urgency=medium

  * New upstream release 4.8.3

 -- Joel Rosdahl <joel@debian.org>  Sat, 16 Sep 2023 12:46:26 +0200

## ccache 4.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -66,11 +66,13 @@
   set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
 endif()
 
+include(CIBuildType)
+include(DefaultBuildType)
 include(UseFastestLinker)
+include(StaticLinkSupport)
 include(StandardSettings)
 include(StandardWarnings)
-include(CIBuildType)
-include(DefaultBuildType)
+include(EnableCcache)
 
 #
 # Configuration
@@ -81,41 +83,24 @@
 include(GenerateVersionFile)
 
 #
-# Static link configuration
+# Third party
 #
 
-set(STATIC_LINK_DEFAULT OFF)
-if(WIN32)
-  set(STATIC_LINK_DEFAULT ON)
+set(ZSTD_FROM_INTERNET AUTO CACHE STRING "Download and use libzstd from the Internet")
+set_property(CACHE ZSTD_FROM_INTERNET PROPERTY STRINGS AUTO ON OFF)
+
+set(HIREDIS_FROM_INTERNET AUTO CACHE STRING "Download and use libhiredis from the Internet")
+set_property(CACHE HIREDIS_FROM_INTERNET PROPERTY STRINGS AUTO ON OFF)
+
+option(
+  OFFLINE "Do not download anything from the internet"
+  "$(FETCHCONTENT_FULLY_DISCONNECTED}"
+)
+if(OFFLINE)
+  set(FETCHCONTENT_FULLY_DISCONNECTED ON)
+  set(ZSTD_FROM_INTERNET OFF)
+  set(HIREDIS_FROM_INTERNET OFF)
 endif()
-
-option(STATIC_LINK "Prefer linking libraries statically" ${STATIC_LINK_DEFAULT})
-
-if(STATIC_LINK)
-  list(INSERT CMAKE_FIND_LIBRARY_SUFFIXES 0 "${CMAKE_STATIC_LIBRARY_SUFFIX}")
-  set(CMAKE_LINK_SEARCH_START_STATIC ON)
-
-  # Link MSVC runtime statically.
-  if(MSVC)
-    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
-  # Link MINGW runtime statically.
-  elseif(WIN32)
-    if((CMAKE_CXX_COMPILER_ID STREQUAL GNU) OR (CMAKE_CXX_COMPILER_ID STREQUAL Clang))
-      list(APPEND CCACHE_EXTRA_LIBS -static-libgcc -static-libstdc++ -static -lwinpthread -dynamic)
-    endif()
-    if(CMAKE_CXX_COMPILER_ID STREQUAL Clang)
-      list(APPEND CCACHE_EXTRA_LIBS -fuse-ld=lld)
-    endif()
-  endif()
-endif()
-
-#
-# Third party
-#
-option(ZSTD_FROM_INTERNET
-  "Download and use libzstd from the Internet if not available" ON)
-option(HIREDIS_FROM_INTERNET
-  "Download and use libhiredis from the Internet if not available" ON)
 
 find_package(zstd 1.1.2 MODULE REQUIRED)

=== src/storage/CMakeLists.txt ===
add_subdirectory(local)
add_subdirectory(remote)

set(
  sources
  Storage.cpp
)

file(GLOB headers *.hpp)
list(APPEND sources ${headers})

target_sources(ccache_framework PRIVATE ${sources})

=== src/third_party/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-add_library(third_party STATIC base32hex.c format.cpp httplib.cpp url.cpp xxhash.c)
+add_library(third_party STATIC format.cpp httplib.cpp url.cpp xxhash.c)
 if(NOT MSVC)
   target_sources(third_party PRIVATE getopt_long.c)
 else()

=== src/util/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,25 @@
 set(
   sources
   Bytes.cpp
+  DirEntry.cpp
   LockFile.cpp
+  LongLivedLockFileManager.cpp
+  TemporaryFile.cpp
   TextTable.cpp
+  ThreadPool.cpp
   TimePoint.cpp
   Tokenizer.cpp
+  UmaskScope.cpp
+  assertions.cpp
+  environment.cpp
+  error.cpp
   file.cpp
+  filesystem.cpp
+  logging.cpp
   path.cpp
+  process.cpp
   string.cpp
+  time.cpp
   zstd.cpp
 )

=== src/third_party/blake3/CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,11 @@
 
   # First check if it's possible to use the assembler variant for the feature.
   string(TOUPPER "have_asm_${feature}" have_feature)
-  if(NOT DEFINED "${have_feature}" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
+  if(NOT DEFINED "${have_feature}" AND CMAKE_SIZEOF_VOID_P EQUAL 8
+# Force intrinsic version for msbuild because of a bug in the cmake generator
+# or msbuild itself with masm flags.
+      AND NOT CMAKE_GENERATOR MATCHES "Visual Studio")
+
     if(NOT CMAKE_REQUIRED_QUIET)
       message(STATUS "Performing Test ${have_feature}")
     endif()

=== debian/changelog ===
ccache (4.9.1-1) unstable; urgency=medium

  * New upstream release 4.9.1 (closes: #1062810)

 -- Joel Rosdahl <joel@debian.org>  Mon, 05 Feb 2024 21:15:10 +0100

ccache (4.9-1) unstable; urgency=medium

  * Remove debian/ccache.triggers on clean (closes: #1060243)
  * New upstream release 4.9
  * Update debian/copyright
  * Bump Standards-Version to 4.6.2 with no changes

 -- Joel Rosdahl <joel@debian.org>  Mon, 15 Jan 2024 21:39:08 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
 Build-Depends: debhelper-compat (= 13), elfutils, cmake, libzstd-dev, libhiredis-dev (>= 0.14.1), asciidoctor
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://ccache.dev
 Vcs-Browser: https://salsa.debian.org/debian/ccache
 Vcs-Git: https://salsa.debian.org/debian/ccache.git

=== debian/rules ===
#!/usr/bin/make -f

export ASMFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/ccache.triggers

override_dh_install:
	dh_install
	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/update-ccache-symlinks.in >debian/ccache/usr/sbin/update-ccache-symlinks

override_dh_installdocs:
	dh_installdocs
	cd debian/ccache/usr/share/doc/ccache && mv NEWS.html changelog.html
	cd debian/ccache/usr/share/doc/ccache && mv MANUAL.html manual.html

override_dh_installchangelogs:
	dh_installchangelogs doc/NEWS.adoc

override_dh_installdeb:
	sed s/%DEB_HOST_MULTIARCH%/$(DEB_HOST_MULTIARCH)/ debian/ccache.triggers.in >debian/ccache.triggers
	dh_installdeb

## ccache 4.10.1

=== debian/changelog ===
ccache (4.10.1-1) unstable; urgency=medium

  * New upstream release 4.10.1
  * Update copyright for new version
  * Update build dependencies and rules for new version
  * Update to Standards-Version 4.7.0 with no changes

 -- Joel Rosdahl <joel@debian.org>  Mon, 01 Jul 2024 09:00:23 +0200

## ccache 4.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -66,6 +66,7 @@
   set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ON)
 endif()
 
+include(Utils)
 include(CIBuildType)
 include(DefaultBuildType)
 include(UseFastestLinker)
@@ -78,37 +79,13 @@
 # Configuration
 #
 
+option(REDIS_STORAGE_BACKEND "Enable Redis remote storage" ON)
+option(ENABLE_TESTING "Enable tests" ON)
+
 include(InstallDirs)
 include(GenerateConfigurationFile)
 include(GenerateVersionFile)
-
-#
-# Third party
-#
-
-set(ZSTD_FROM_INTERNET AUTO CACHE STRING "Download and use libzstd from the Internet")
-set_property(CACHE ZSTD_FROM_INTERNET PROPERTY STRINGS AUTO ON OFF)
-
-set(HIREDIS_FROM_INTERNET AUTO CACHE STRING "Download and use libhiredis from the Internet")
-set_property(CACHE HIREDIS_FROM_INTERNET PROPERTY STRINGS AUTO ON OFF)
-
-option(
-  OFFLINE "Do not download anything from the internet"
-  "$(FETCHCONTENT_FULLY_DISCONNECTED}"
-)
-if(OFFLINE)
-  set(FETCHCONTENT_FULLY_DISCONNECTED ON)
-  set(ZSTD_FROM_INTERNET OFF)
-  set(HIREDIS_FROM_INTERNET OFF)
-endif()
-
-find_package(zstd 1.1.2 MODULE REQUIRED)
-
-option(REDIS_STORAGE_BACKEND "Enable Redis remote storage" ON)
-
-if(REDIS_STORAGE_BACKEND)
-  find_package(hiredis 0.13.3 MODULE REQUIRED)
-endif()
+include(Dependencies)
 
 #
 # Special flags
@@ -117,17 +94,17 @@
 # doesn't get scanned.
 #
 include(CodeAnalysis)
-option(ENABLE_TRACING "Enable possibility to use internal ccache tracing" OFF)
 
 #
 # Source code
 #
-add_subdirectory(src)
+add_subdirectory(src/third_party)
+add_subdirectory(src/ccache)
 
 #
 # ccache executable
 #
-add_executable(ccache src/main.cpp)
+add_executable(ccache src/ccache/main.cpp)
 target_link_libraries(ccache PRIVATE standard_settings standard_warnings ccache_framework)
 
 #
@@ -151,16 +128,12 @@
 #
 # Tests
 #
-option(ENABLE_TESTING "Enable tests" ON)
 if(ENABLE_TESTING)
   enable_testing()
   add_subdirectory(unittest)
   add_subdirectory(test)
 
-  # Note: VERSION_GREATER_EQUAL requires CMake 3.17
-  if(NOT ${CMAKE_VERSION} VERSION_LESS "3.17")
-    list(APPEND CMAKE_CTEST_ARGUMENTS "--output-on-failure")
-  endif()
+  list(APPEND CMAKE_CTEST_ARGUMENTS "--output-on-failure")
 
   # Add "check" target which compiles and runs tests.
   set(
@@ -192,3 +165,17 @@
   COMMENT "Checking code formatting"
   USES_TERMINAL
   WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
+
+#
+# Configuration summary
+#
+
+message(STATUS)
+message(STATUS "Configuration summary:")
+message(STATUS "  Storage backends:")
+message(STATUS "    file  ON")
+message(STATUS "    http  ON")
+message(STATUS "    redis ${REDIS_STORAGE_BACKEND}")
+message(STATUS "  Dependencies:")
+print_dependency_summary("    ")
+message(STATUS)

=== unittest/CMakeLists.txt ===
set(
  source_files
  TestUtil.cpp
  main.cpp
  test_Args.cpp
  test_Config.cpp
  test_Depfile.cpp
  test_Hash.cpp
  test_argprocessing.cpp
  test_ccache.cpp
  test_compopt.cpp
  test_compression_types.cpp
  test_core_AtomicFile.cpp
  test_core_MsvcShowIncludesOutput.cpp
  test_core_Statistics.cpp
  test_core_StatisticsCounters.cpp
  test_core_StatsLog.cpp
  test_core_common.cpp
  test_hashutil.cpp
  test_storage_local_StatsFile.cpp
  test_storage_local_util.cpp
  test_util_BitSet.cpp
  test_util_Bytes.cpp
  test_util_DirEntry.cpp
  test_util_Duration.cpp
  test_util_LockFile.cpp
  test_util_TextTable.cpp
  test_util_TimePoint.cpp
  test_util_Tokenizer.cpp
  test_util_XXH3_128.cpp
  test_util_XXH3_64.cpp
  test_util_conversion.cpp
  test_util_environment.cpp
  test_util_expected.cpp
  test_util_file.cpp
  test_util_path.cpp
  test_util_string.cpp
  test_util_zstd.cpp
)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files test_InodeCache.cpp)
endif()

if(WIN32)
  list(APPEND source_files test_bsdmkstemp.cpp)
endif()

file(GLOB headers *.hpp)
list(APPEND source_files ${headers})

add_executable(unittest ${source_files})

# Turn off /Zc:preprocessor for this test because it triggers a bug in some older Windows 10 SDK headers.
if(MSVC AND NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND
    CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "19.25" AND
    CMAKE_SYSTEM_VERSION VERSION_LESS "10.0.22621")
  set_source_files_properties(test_util_DirEntry.cpp PROPERTIES COMPILE_FLAGS /Zc:preprocessor-)
endif()

target_link_libraries(
  unittest
  PRIVATE standard_settings standard_warnings ccache_framework dep_doctest
)

target_include_directories(unittest PRIVATE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${ccache_SOURCE_DIR}/src)

add_test(NAME unittest COMMAND unittest)

=== src/ccache/core/CMakeLists.txt ===
set(
  sources
  AtomicFile.cpp
  CacheEntry.cpp
  FileRecompressor.cpp
  Manifest.cpp
  MsvcShowIncludesOutput.cpp
  Result.cpp
  ResultExtractor.cpp
  ResultInspector.cpp
  ResultRetriever.cpp
  Statistics.cpp
  StatisticsCounters.cpp
  StatsLog.cpp
  common.cpp
  mainoptions.cpp
  types.cpp
)

file(GLOB headers *.hpp)
list(APPEND sources ${headers})

target_sources(ccache_framework PRIVATE ${sources})

=== src/ccache/util/CMakeLists.txt ===
set(
  sources
  Bytes.cpp
  DirEntry.cpp
  LockFile.cpp
  LongLivedLockFileManager.cpp
  MemoryMap.cpp
  TemporaryFile.cpp
  TextTable.cpp
  ThreadPool.cpp
  TimePoint.cpp
  Tokenizer.cpp
  UmaskScope.cpp
  assertions.cpp
  cpu.cpp
  environment.cpp
  error.cpp
  file.cpp
  filesystem.cpp
  logging.cpp
  path.cpp
  process.cpp
  string.cpp
  time.cpp
  zstd.cpp
)

file(GLOB headers *.hpp)
list(APPEND sources ${headers})

target_sources(ccache_framework PRIVATE ${sources})

=== src/third_party/blake3/CMakeLists.txt ===
register_dependency(Blake3 BUNDLED 1.5.1)

add_library(
  dep_blake3 STATIC
  "${CMAKE_CURRENT_SOURCE_DIR}/blake3/blake3.c"
  "${CMAKE_CURRENT_SOURCE_DIR}/blake3/blake3_dispatch.c"
  "${CMAKE_CURRENT_SOURCE_DIR}/blake3/blake3_portable.c"
)

target_include_directories(dep_blake3 INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/blake3")
target_link_libraries(dep_blake3 PRIVATE standard_settings)

if(MSVC)
  # No object file is created if masm is passed the compile options from
  # standard_settings, so don't pass any flags at all to assembler (as no
  # flags are needed anyway).
  string(REPLACE "<FLAGS> " "" CMAKE_ASM_MASM_COMPILE_OBJECT "${CMAKE_ASM_MASM_COMPILE_OBJECT}")
endif()

include(CheckCSourceCompiles)

function(_add_blake3_source_if_enabled feature msvc_flags others_flags intrinsic)
  if(MSVC)
    set(compile_flags "${msvc_flags}")
  else()
    set(compile_flags "${others_flags}")
  endif()

  if(MSVC)
    set(suffix "_x86-64_windows_msvc.asm")
  elseif(WIN32 OR CYGWIN)
    set(suffix "_x86-64_windows_gnu.S")
  else()
    set(suffix "_x86-64_unix.S")
  endif()

  # First check if it's possible to use the assembler variant for the feature.
  string(TOUPPER "have_asm_${feature}" have_feature)
  if(NOT DEFINED "${have_feature}" AND CMAKE_SIZEOF_VOID_P EQUAL 8
      # Force intrinsic version for msbuild because of a bug in the CMake
      # generator or msbuild itself with masm flags.
      AND NOT CMAKE_GENERATOR MATCHES "Visual Studio")

    if(NOT CMAKE_REQUIRED_QUIET)
      message(STATUS "Performing Test ${have_feature}")
    endif()

    set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)

    # Must set CMAKE_ASM_MASM_CREATE_STATIC_LIBRARY explicitly otherwise
    # try_compile fails, see
    # <https://discourse.cmake.org/t/building-lib-file-from-asm-cmake-bug/1959>.
    try_compile(
      ${have_feature}
      ${CMAKE_CURRENT_BINARY_DIR}
      "${CMAKE_CURRENT_SOURCE_DIR}/blake3/blake3_${feature}${suffix}"
      CMAKE_FLAGS -DCMAKE_ASM_MASM_CREATE_STATIC_LIBRARY=${CMAKE_C_CREATE_STATIC_LIBRARY}
      COMPILE_DEFINITIONS ${compile_flags}
    )

    unset(CMAKE_TRY_COMPILE_TARGET_TYPE)

    if(NOT CMAKE_REQUIRED_QUIET)
      if (${${have_feature}})
        message(STATUS "Performing Test ${have_feature} - Success")
      else()
        message(STATUS "Performing Test ${have_feature} - Failed")
      endif()
    endif()
  endif()

  # If the assembler variant didn't work, try the C variant.
  if(NOT ${have_feature})
    string(TOUPPER "have_c_${feature}" have_feature)
    set(suffix ".c")

    set(CMAKE_REQUIRED_FLAGS ${compile_flags})
    check_c_source_compiles(
      [=[
        #include <immintrin.h>
        int main() { ${intrinsic}; return 0; }
      ]=]
      ${have_feature})
    unset(CMAKE_REQUIRED_FLAGS)
  endif()

  if(${have_feature})
    target_sources(
      dep_blake3
      PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/blake3/blake3_${feature}${suffix}"
    )
    if(suffix STREQUAL ".c")
      if(MINGW AND feature STREQUAL "avx512")
        # Workaround for <https://gcc.gnu.org/bugzilla/show_bug.cgi?id=65782>.
        # Taken from blake3's build.rs.
        set(compile_flags "${compile_flags} -fno-asynchronous-unwind-tables")
      endif()
      set_property(
        SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/blake3/blake3_${feature}${suffix}"
        APPEND PROPERTY COMPILE_FLAGS ${compile_flags})
    elseif(NOT MSVC)
      set_property(
        SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/blake3/blake3_${feature}${suffix}"
        PROPERTY COMPILE_FLAGS ${compile_flags})
    endif()
  else()
    string(TOUPPER "blake3_no_${feature}" no_feature)
    target_compile_definitions(dep_blake3 PRIVATE ${no_feature})
  endif()
endfunction()

# https://software.intel.com/sites/landingpage/IntrinsicsGuide/
_add_blake3_source_if_enabled(sse2 "" "-msse2" "_mm_set1_epi32(42)")
_add_blake3_source_if_enabled(sse41 "" "-msse4.1" "_mm_test_all_ones(_mm_set1_epi32(42))")
_add_blake3_source_if_enabled(avx2 "/arch:AVX2" "-mavx2" "_mm256_abs_epi8(_mm256_set1_epi32(42))")
_add_blake3_source_if_enabled(avx512 "/arch:AVX512" "-mavx512f -mavx512vl" "_mm256_abs_epi64(_mm256_set1_epi32(42))")

# Neon is always available on AArch64
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  # https://developer.arm.com/architectures/instruction-sets/simd-isas/neon/intrinsics
  check_c_source_compiles(
    [=[
      #include <arm_neon.h>
      int main() { vdupq_n_s32(42); return 0; }
    ]=]
    HAVE_NEON)
  if(HAVE_NEON)
    target_sources(dep_blake3 PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/blake3/blake3_neon.c")
    target_compile_definitions(dep_blake3 PRIVATE BLAKE3_USE_NEON)
  endif()
endif()

file(GLOB headers *.h)
target_sources(dep_blake3 PRIVATE ${headers})

=== src/third_party/cpp-httplib/CMakeLists.txt ===
register_dependency(CppHttplib BUNDLED 0.15.3)
add_header_only_library(cpphttplib DIR "${CMAKE_CURRENT_SOURCE_DIR}")

=== debian/changelog ===
ccache (4.10.2-1build1) plucky; urgency=medium

  * Rebuild against latest fmtlib

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 13 Nov 2024 10:06:17 -0500

ccache (4.10.2-1) unstable; urgency=medium

  * New upstream release 4.10.2

 -- Joel Rosdahl <joel@debian.org>  Mon, 22 Jul 2024 20:56:29 +0200

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,11 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	$(RM) debian/ccache.triggers
+
+override_dh_auto_configure:
+	dh_auto_configure -- \
+	  -D DEPS=LOCAL \
+	  -D DEP_CPPHTTPLIB=BUNDLED
 
 override_dh_install:
 	dh_install

## ccache 4.11.2

=== src/ccache/CMakeLists.txt ===
set(
  source_files
  argprocessing.cpp
  args.cpp
  ccache.cpp
  compopt.cpp
  config.cpp
  context.cpp
  depfile.cpp
  execute.cpp
  hash.cpp
  hashutil.cpp
  language.cpp
  progressbar.cpp
  version.cpp
)

if(INODE_CACHE_SUPPORTED)
  list(APPEND source_files inodecache.cpp)
endif()

if(NOT WIN32)
  list(APPEND source_files signalhandler.cpp)
endif()

file(GLOB headers *.hpp)
list(APPEND source_files ${headers})

add_library(ccache_framework STATIC ${source_files})

if(WIN32)
  list(APPEND CCACHE_EXTRA_LIBS psapi)
endif()

if(CCACHE_EXTRA_LIBS)
  target_link_libraries(
    ccache_framework
    PRIVATE "${CCACHE_EXTRA_LIBS}"
  )
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(
  ccache_framework
  PUBLIC
    dep_blake3
    dep_cxxurl
    dep_fmt
    dep_nonstdspan
    dep_tlexpected
    dep_xxhash
  PRIVATE
    dep_zstd
    standard_settings
    standard_warnings
    Threads::Threads
)

if(WIN32)
  target_link_libraries(ccache_framework PUBLIC win32_compat)
endif()

get_filename_component(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR} DIRECTORY)
target_include_directories(ccache_framework PUBLIC ${CMAKE_BINARY_DIR} ${SRC_DIR})

if(REDIS_STORAGE_BACKEND)
  target_compile_definitions(ccache_framework PUBLIC -DHAVE_REDIS_STORAGE_BACKEND)
  target_link_libraries(ccache_framework PRIVATE dep_hiredis)
endif()

if(HTTP_STORAGE_BACKEND)
  target_compile_definitions(ccache_framework PUBLIC -DHAVE_HTTP_STORAGE_BACKEND)
  target_link_libraries(ccache_framework PRIVATE dep_cpphttplib)
endif()

add_executable(test-lockfile test_lockfile.cpp)
target_link_libraries(test-lockfile PRIVATE standard_settings standard_warnings ccache_framework)

add_subdirectory(core)
add_subdirectory(storage)
add_subdirectory(util)

=== debian/changelog ===
ccache (4.11.2-2) unstable; urgency=medium

  * Apply upstream patch for stderr output in test suite (closes: #1103590)

 -- Joel Rosdahl <joel@debian.org>  Sun, 20 Apr 2025 09:30:19 +0200

ccache (4.11.2-1) unstable; urgency=medium

  * New upstream release 4.11.2
  * Update copyright for new version

 -- Joel Rosdahl <joel@debian.org>  Sat, 22 Mar 2025 14:26:46 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: devel
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
-Build-Depends: debhelper-compat (= 13), elfutils, cmake, libzstd-dev, libhiredis-dev (>= 0.14.1), asciidoctor
-Standards-Version: 4.6.2
+Build-Depends: asciidoctor, cmake, debhelper-compat (= 13), doctest-dev (>= 2.4.6), elfutils, libexpected-dev (>= 1.1.0), libfmt-dev (>= 8.0.0), libhiredis-dev (>= 0.14.1), libxxhash-dev (>= 0.8.0), libzstd-dev (>= 1.3.4)
+Standards-Version: 4.7.0
 Homepage: https://ccache.dev
 Vcs-Browser: https://salsa.debian.org/debian/ccache
 Vcs-Git: https://salsa.debian.org/debian/ccache.git

=== debian/watch ===
version=4
https://github.com/ccache/ccache/releases .*/ccache-([\d.]*)\.tar\.xz

## ccache 4.11.3

=== debian/changelog ===
ccache (4.11.3-1) unstable; urgency=medium

  * New upstream release 4.11.3 (closes: #1112767)
  * Drop obsolete patch
  * Bump to Standards-Version 4.7.2 with no changes

 -- Joel Rosdahl <joel@debian.org>  Mon, 01 Sep 2025 21:55:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
 Build-Depends: asciidoctor, cmake, debhelper-compat (= 13), doctest-dev (>= 2.4.6), elfutils, libexpected-dev (>= 1.1.0), libfmt-dev (>= 8.0.0), libhiredis-dev (>= 0.14.1), libxxhash-dev (>= 0.8.0), libzstd-dev (>= 1.3.4)
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://ccache.dev
 Vcs-Browser: https://salsa.debian.org/debian/ccache
 Vcs-Git: https://salsa.debian.org/debian/ccache.git

## ccache 4.12

=== debian/changelog ===
ccache (4.12-1) unstable; urgency=medium

  * New upstream release 4.12

 -- Joel Rosdahl <joel@debian.org>  Thu, 18 Sep 2025 21:34:33 +0200

## ccache 4.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.15)
+cmake_minimum_required(VERSION 3.18)
 
 project(ccache LANGUAGES C CXX ASM ASM_MASM)
 if(MSVC)
@@ -80,6 +80,7 @@
 #
 
 option(REDIS_STORAGE_BACKEND "Enable Redis remote storage" ON)
+option(HTTP_STORAGE_BACKEND "Enable HTTP remote storage" ON)
 option(ENABLE_TESTING "Enable tests" ON)
 
 include(InstallDirs)
@@ -101,11 +102,24 @@
 add_subdirectory(src/third_party)
 add_subdirectory(src/ccache)
 
+# Win32 version library
+if(WIN32)
+  add_library(ccache_win32_manifest OBJECT "${CMAKE_CURRENT_BINARY_DIR}/version.rc")
+  set_property(TARGET ccache_win32_manifest PROPERTY INCLUDE_DIRECTORIES "")
+endif()
+
+
 #
 # ccache executable
 #
 add_executable(ccache src/ccache/main.cpp)
 target_link_libraries(ccache PRIVATE standard_settings standard_warnings ccache_framework)
+if(WIN32)
+  if(MSVC)
+      target_link_options(ccache PUBLIC "/MANIFEST:NO")
+  endif()
+  target_link_libraries(ccache PRIVATE ccache_win32_manifest)
+endif()
 
 #
 # Documentation
@@ -174,7 +188,7 @@
 message(STATUS "Configuration summary:")
 message(STATUS "  Storage backends:")
 message(STATUS "    file  ON")
-message(STATUS "    http  ON")
+message(STATUS "    http  ${HTTP_STORAGE_BACKEND}")
 message(STATUS "    redis ${REDIS_STORAGE_BACKEND}")
 message(STATUS "  Dependencies:")
 print_dependency_summary("    ")

=== doc/CMakeLists.txt ===
find_program(ASCIIDOCTOR_EXE asciidoctor)
mark_as_advanced(ASCIIDOCTOR_EXE) # Don't show in CMake UIs

if(NOT ASCIIDOCTOR_EXE)
  message(WARNING "Could not find asciidoctor; documentation will not be generated")
else()
  function(generate_doc backend adoc_file output_file)
    add_custom_command(
      OUTPUT "${output_file}"
      COMMAND
        ${ASCIIDOCTOR_EXE}
          -o "${output_file}"
          -a revnumber="${CCACHE_VERSION}"
          -a icons=font
          -a toc=left
          -a sectanchors
          -a stylesheet="${CMAKE_CURRENT_SOURCE_DIR}/ccache-doc.css"
          -b "${backend}"
          "${CMAKE_SOURCE_DIR}/${adoc_file}"
      MAIN_DEPENDENCY "${CMAKE_SOURCE_DIR}/${adoc_file}"
      DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/ccache-doc.css"
    )
    if(${backend} STREQUAL manpage)
      # Convert monospace to bold since that's typically rendered better when
      # viewing the man page.
      add_custom_command(
        OUTPUT "${output_file}"
        COMMAND perl -pi -e "'s!\\\\f\\(CR(.*?)\\\\fP!\\\\fB\\1\\\\fP!g'" "${output_file}"
        APPEND
      )
    endif()
    if("${backend}" STREQUAL manpage)
      install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/${output_file}"
        DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
      )
    else()
      set(html_doc_files "${html_doc_files}" "${output_file}" PARENT_SCOPE)
      install(
        FILES "${CMAKE_SOURCE_DIR}/${adoc_file}" "${CMAKE_CURRENT_BINARY_DIR}/${output_file}"
        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
      )
    endif()
  endfunction()

  #
  # HTML documentation
  #
  generate_doc(html    LICENSE.adoc     LICENSE.html)
  generate_doc(html    doc/AUTHORS.adoc AUTHORS.html)
  generate_doc(html    doc/MANUAL.adoc  MANUAL.html)
  generate_doc(html    doc/NEWS.adoc    NEWS.html)
  add_custom_target(doc-html DEPENDS "${html_doc_files}")

  #
  # Man page
  #
  generate_doc(manpage doc/MANUAL.adoc ccache.1)
  add_custom_target(doc-man-page DEPENDS ccache.1)

  add_custom_target(doc ALL DEPENDS doc-html doc-man-page)
endif()

=== unittest/CMakeLists.txt ===
--- 
+++ 
@@ -1,45 +1,47 @@
 set(
   source_files
-  TestUtil.cpp
   main.cpp
-  test_Args.cpp
-  test_Config.cpp
-  test_Depfile.cpp
-  test_Hash.cpp
   test_argprocessing.cpp
   test_ccache.cpp
   test_compopt.cpp
   test_compression_types.cpp
-  test_core_AtomicFile.cpp
-  test_core_MsvcShowIncludesOutput.cpp
-  test_core_Statistics.cpp
-  test_core_StatisticsCounters.cpp
-  test_core_StatsLog.cpp
+  test_config.cpp
+  test_core_atomicfile.cpp
   test_core_common.cpp
+  test_core_msvcshowincludesoutput.cpp
+  test_core_statistics.cpp
+  test_core_statisticscounters.cpp
+  test_core_statslog.cpp
+  test_depfile.cpp
+  test_hash.cpp
   test_hashutil.cpp
-  test_storage_local_StatsFile.cpp
+  test_storage_local_statsfile.cpp
   test_storage_local_util.cpp
-  test_util_BitSet.cpp
-  test_util_Bytes.cpp
-  test_util_DirEntry.cpp
-  test_util_Duration.cpp
-  test_util_LockFile.cpp
-  test_util_TextTable.cpp
-  test_util_TimePoint.cpp
-  test_util_Tokenizer.cpp
-  test_util_XXH3_128.cpp
-  test_util_XXH3_64.cpp
+  test_util_args.cpp
+  test_util_bitset.cpp
+  test_util_bytes.cpp
+  test_util_clang.cpp
   test_util_conversion.cpp
+  test_util_direntry.cpp
+  test_util_duration.cpp
   test_util_environment.cpp
+  test_util_exec.cpp
   test_util_expected.cpp
   test_util_file.cpp
+  test_util_lockfile.cpp
   test_util_path.cpp
   test_util_string.cpp
+  test_util_texttable.cpp
+  test_util_timepoint.cpp
+  test_util_tokenizer.cpp
+  test_util_xxh3_128.cpp
+  test_util_xxh3_64.cpp
   test_util_zstd.cpp
+  testutil.cpp
 )
 
 if(INODE_CACHE_SUPPORTED)
-  list(APPEND source_files test_InodeCache.cpp)
+  list(APPEND source_files test_inodecache.cpp)
 endif()
 
 if(WIN32)

=== src/ccache/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,6 @@
 set(
   source_files
   argprocessing.cpp
-  args.cpp
   ccache.cpp
   compopt.cpp
   config.cpp

=== src/third_party/CMakeLists.txt ===
add_subdirectory(cxxurl)
add_subdirectory(win32-compat)

if(NOT TARGET dep_blake3)
  add_subdirectory(blake3)
endif()
if(HTTP_STORAGE_BACKEND)
  if(NOT TARGET dep_cpphttplib)
    add_subdirectory(cpp-httplib)
  endif()
endif()
if(NOT TARGET dep_fmt)
  add_subdirectory(fmt)
endif()
if(NOT TARGET dep_nonstdspan)
  add_subdirectory(nonstd-span)
endif()
if(NOT TARGET dep_tlexpected)
  add_subdirectory(tl-expected)
endif()

=== src/third_party/blake3/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-register_dependency(Blake3 BUNDLED 1.5.1)
+register_dependency(Blake3 BUNDLED 1.8.2)
 
 add_library(
   dep_blake3 STATIC
@@ -115,8 +115,8 @@
 _add_blake3_source_if_enabled(avx2 "/arch:AVX2" "-mavx2" "_mm256_abs_epi8(_mm256_set1_epi32(42))")
 _add_blake3_source_if_enabled(avx512 "/arch:AVX512" "-mavx512f -mavx512vl" "_mm256_abs_epi64(_mm256_set1_epi32(42))")
 
-# Neon is always available on AArch64
-if(CMAKE_SIZEOF_VOID_P EQUAL 8)
+# Neon is always available on AArch64, but blake3_neon.c only supports little-endian
+if(CMAKE_SIZEOF_VOID_P EQUAL 8 AND CMAKE_C_BYTE_ORDER STREQUAL "LITTLE_ENDIAN")
   # https://developer.arm.com/architectures/instruction-sets/simd-isas/neon/intrinsics
   check_c_source_compiles(
     [=[

=== src/third_party/cpp-httplib/CMakeLists.txt ===
register_dependency(CppHttplib BUNDLED 0.20.0)
add_header_only_library(cpphttplib DIR "${CMAKE_CURRENT_SOURCE_DIR}")

=== src/third_party/cxxurl/CMakeLists.txt ===
add_library(dep_cxxurl STATIC EXCLUDE_FROM_ALL "cxxurl/url.cpp")
target_include_directories(
  dep_cxxurl
  SYSTEM INTERFACE "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
)

=== debian/changelog ===
ccache (4.12.1-1) unstable; urgency=medium

  * New upstream release 4.12.1
  * Mark ccache as "Multi-Arch: foreign" (closes: #1116707)

 -- Joel Rosdahl <joel@debian.org>  Wed, 01 Oct 2025 21:21:39 +0200

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
 
 Package: ccache
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: distcc | icecc
 Description: Compiler cache for fast recompilation of C/C++ code

=== debian/tests/control ===
Tests: run-testsuites
Depends: binutils, ccache, elfutils, gcc, libc-dev
